--[[
Description: This plugin is part of the "Titan Panel [Professions] Multi" addon. It shows Mining Reagents.
Site: http://www.curse.com/addons/wow/titan-panel-professions-multi
Author: Canettieri
Special Thanks to Eliote.
--]]

local ADDON_NAME, L = ...;
local ACE = LibStub("AceLocale-3.0"):GetLocale("Titan", true)
local version = GetAddOnMetadata(ADDON_NAME, "Version")
local ID = "TITAN_RESMINIM_BFA"
local moneliteOre = 0
local startMonelite = 0

local stormSilver = 0
local startStormSilver = 0

local platinumOre = 0
local startPlatinum = 0
-----------------------------------------------
local function getMoneliteOre()
	return GetItemCount(152512, true) or 0
end
-----------------------------------------------
local function getStormSilver()
	return GetItemCount(152579, true) or 0
end
-----------------------------------------------
local function getPlatinumOre()
	return GetItemCount(152513, true) or 0
end
-----------------------------------------------
local function GetButtonText(self, id)
	local moneliteText
	if not moneliteOre then
		moneliteText = "  |TInterface\\Icons\\inv_ore_monalite:0|t "..TitanUtils_GetHighlightText("0")
	else
		moneliteText = "  |TInterface\\Icons\\inv_ore_monalite:0|t "..TitanUtils_GetHighlightText(moneliteOre)
	end

	local stormSilverText
	if not stormSilver then
		stormSilverText = "  |TInterface\\Icons\\inv_ore_stormsilver:0|t "..TitanUtils_GetHighlightText("0")
	else
		stormSilverText = "  |TInterface\\Icons\\inv_ore_stormsilver:0|t "..TitanUtils_GetHighlightText(stormSilver)
	end

	local platinumText
	if not platinumOre then
		platinumText = "  |TInterface\\Icons\\inv_ore_platinum:0|t "..TitanUtils_GetHighlightText("0")
	else
		platinumText = "  |TInterface\\Icons\\inv_ore_platinum:0|t "..TitanUtils_GetHighlightText(platinumOre)
	end

	local barBalanceMonelite = ""
	if TitanGetVar(ID, "ShowBarBalance") then
		if (moneliteOre - startMonelite) > 0 then
			barBalanceMonelite = " |cFF69FF69["..(moneliteOre - startMonelite).."]"
		elseif (moneliteOre - startMonelite) < 0 then
			barBalanceMonelite = " |cFFFF2e2e["..(moneliteOre - startMonelite).."]"
		end
	end

	local barBalanceStormSilver = ""
	if TitanGetVar(ID, "ShowBarBalance") then
		if (stormSilver - startStormSilver) > 0 then
			barBalanceStormSilver = " |cFF69FF69["..(stormSilver - startStormSilver).."]"
		elseif (stormSilver - startStormSilver) < 0 then
			barBalanceStormSilver = " |cFFFF2e2e["..(stormSilver - startStormSilver).."]"
		end
	end

	local barBalancePlatinum = ""
	if TitanGetVar(ID, "ShowBarBalance") then
		if (platinumOre - startPlatinum) > 0 then
			barBalancePlatinum = " |cFF69FF69["..(platinumOre - startPlatinum).."]"
		elseif (platinumOre - startPlatinum) < 0 then
			barBalancePlatinum = " |cFFFF2e2e["..(platinumOre - startPlatinum).."]"
		end
	end

	local moneliteBar = moneliteText..barBalanceMonelite.." "
	if TitanGetVar(id, "HideMonelite") then
		moneliteBar = ""
	end

	local stormSilverBar = stormSilverText..barBalanceStormSilver.." "
	if TitanGetVar(id, "HideStormSilver") then
		stormSilverBar = ""
	end

	local platinumBar = platinumText..barBalancePlatinum.." "
	if TitanGetVar(id, "HidePlatinum") then
		platinumBar = ""
	end

	return moneliteBar..stormSilverBar..platinumBar
end
-----------------------------------------------
local function GetTooltipText(self, id)

	local moneliteBag = "\r"..L["monelite"].."\r"..L["totalbag"]..TitanUtils_GetHighlightText(GetItemCount(152512)).."\r"
	local moneliteBank = L["totalbank"]..TitanUtils_GetHighlightText(GetItemCount(152512, true) - GetItemCount(152512))

	local stormSilverBag = L["stormSilver"].."\r"..L["totalbag"]..TitanUtils_GetHighlightText(GetItemCount(152579)).."\r"
	local stormSilverBank = L["totalbank"]..TitanUtils_GetHighlightText(GetItemCount(152579, true) - GetItemCount(152579))

	local platinumBag = L["platinumOre"].."\r"..L["totalbag"]..TitanUtils_GetHighlightText(GetItemCount(152513)).."\r"
	local platinumBank = L["totalbank"]..TitanUtils_GetHighlightText(GetItemCount(152513, true) - GetItemCount(152513))

	local valueText = "" -- Difere com e sem reagente
	if moneliteOre == 0 and stormSilver == 0 and platinumOre == 0 then
		valueText = "\r"..L["info"].."\r|cFFFF2e2e"..L["noreagent"]
	else
		valueText = "\r"..L["info"]..moneliteBag..moneliteBank.."\r\r"..stormSilverBag..stormSilverBank.."\r\r"..platinumBag..platinumBank
	end

	return valueText
end
-----------------------------------------------
local eventsTable = {
	PLAYER_ENTERING_WORLD = function(self)
		self:UnregisterEvent("PLAYER_ENTERING_WORLD")
		self.PLAYER_ENTERING_WORLD = nil

		startMonelite = getMoneliteOre()
		moneliteOre = startMonelite

		startStormSilver = getStormSilver()
		stormSilver = startStormSilver

		startPlatinum = getPlatinumOre()
		platinumOre = startPlatinum

		TitanPanelButton_UpdateButton(self.registry.id)

		self.BAG_UPDATE = function(self, bagID)
			local mlite = getMoneliteOre()
			local ssilver = getStormSilver()
			local plat = getPlatinumOre()
			if moneliteOre == mlite and stormSilver == ssilver and platinumOre == plat then return end

			moneliteOre = mlite
			stormSilver = ssilver
			platinumOre = plat
			TitanPanelButton_UpdateButton(self.registry.id)
		end
		self:RegisterEvent("BAG_UPDATE")
	end
}
-----------------------------------------------
local function PrepareMenu(self, id)
	TitanPanelRightClickMenu_AddTitle(TitanPlugins[id].menuText)
	TitanPanelRightClickMenu_AddToggleIcon(id)

	local info = UIDropDownMenu_CreateInfo();
	info.text = L["showbb"];
	info.func = function() TitanToggleVar(id, "ShowBarBalance"); TitanPanelButton_UpdateButton(id); end
	info.checked = TitanGetVar(id, "ShowBarBalance");
	L_UIDropDownMenu_AddButton(info);

	TitanPanelRightClickMenu_AddSpacer()

	local info = UIDropDownMenu_CreateInfo();
	info.text = L["hide"].." "..L["monelite"];
	info.func = function() TitanToggleVar(id, "HideMonelite"); TitanPanelButton_UpdateButton(id); end
	info.checked = TitanGetVar(id, "HideMonelite");
	L_UIDropDownMenu_AddButton(info);

	local info = UIDropDownMenu_CreateInfo();
	info.text = L["hide"].." "..L["stormSilver"];
	info.func = function() TitanToggleVar(id, "HideStormSilver"); TitanPanelButton_UpdateButton(id); end
	info.checked = TitanGetVar(id, "HideStormSilver");
	L_UIDropDownMenu_AddButton(info);

	local info = UIDropDownMenu_CreateInfo();
	info.text = L["hide"].." "..L["platinumOre"];
	info.func = function() TitanToggleVar(id, "HidePlatinum"); TitanPanelButton_UpdateButton(id); end
	info.checked = TitanGetVar(id, "HidePlatinum");
	L_UIDropDownMenu_AddButton(info);

	TitanPanelRightClickMenu_AddSpacer()
	TitanPanelRightClickMenu_AddCommand(ACE["TITAN_PANEL_MENU_HIDE"], id, TITAN_PANEL_MENU_FUNC_HIDE);
end
-----------------------------------------------
L.Elib({
	id = ID,
	name = "Titan|cFFEC7A37 "..L["mining"].."|r [|cFFEC7A37"..L["rBfA"].."|r] Multi",
	tooltip = L["mining"].."|r [|cFFEC7A37"..L["rBfA"].."|r]",
	icon = "Interface\\Icons\\Trade_mining",
	category = "Profession",
	version = version,
	getButtonText = GetButtonText,
	getTooltipText = GetTooltipText,
	prepareMenu = PrepareMenu,
	savedVariables = {
		ShowIcon = 1,
		DisplayOnRightSide = false,
		ShowBarBalance = false,
		ShowLabelText = false,
		HideMonelite = false,
		HideStormSilver = false,
		HidePlatinum = false,
	},
	eventsTable = eventsTable
})
